<?php /* BISMILLAHIRRAHMANIRRAHEEM */

//-- Configurations:
$filehouseslist = "houseslist.txt";
$fdelimiter = "*|*";
$filehouseprefix = "house";	// For example: $filehouseprefix . $filehousesuffix is "house.txt" or "house"[HID]".txt"
$filehousesuffix = ".txt";		// Script generates file names for houses "house1.txt", "house2.txt" etc
header('Content-Type: application/json; charset=utf-8');
$housepatidseparator = " "; // "00100{$housepatidseparator}Last_Name, First_Name, dd.mm.yyyy"  // "00100  Last_Name, First_Name, dd.mm.yyyy"
$pathworkstation = "/var/samba/trp"; // "/var/samba/trp"
$fileworkstation = "pat-archiv.txt";
$TelAreaCode = "0761"; // Area code to add to tel numbers

$workstations = [	"t0" => "C",
                    "t1" => "D",
                    "r1" => "E",
                    "t6" => "H",
                    "t4" => "F",
                    "t5" => "B"	];

$PatientFields = [	"FName",
							"LName",
							"BDate",
							"Street",
							"ZipCity",
							"Telephone"	];

$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata) INSHAALLAH

//$ret["status"] = ""; // status, true on success, false on failure/ error
$ret["Action"] = $jdata["Action"]; // returns the Action/ Action code, same as request
//$ret["data"] = ""; // contains payload/ return data
//$ret["message"] = ""; // contains error message, if any
if (array_key_exists("HID", $jdata)) {
	$jdata["HID"] = intval($jdata["HID"]);
}
$ret["message"] = "";

if ($jdata["Action"] == "SaveHouse") {
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$filename = $filehouseslist;
		//$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");// or die("Unable to open file: " . $file . "<br />Please check directory/ file permissions");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$HID = 0;
		$i = 0;
		$hidlist = [0];
		$freehid = 0; // Free HID, if any... used to look for gaps in HIDs, for example: If House IDs are [1,2,4], "3" is HID we can use for new House entry.
		$prevhid = 0; // Previous HID
		if (filesize($file) > 0) {
			rewind($f); // just in case
			//$fcontents = fread($f,filesize);
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = trim($house[0]);
						//$houseslist[$i]["House"] = $house[1];
						if (($house[0] == $jdata["HID"]) && (trim($house[1]) == trim($jdata["House"]))) { // Entry exists, then edit (not add new entry)
							$HID = $house[0];
							$houseslist[$i]["House"] = $jdata["House"];
						} else {
							$houseslist[$i]["House"] = $house[1];
						}
						array_push($hidlist, $house[0]);
						$i = $i + 1;
						/*if ($freehid == 0) { // Still not found empty HID slot
							if (($house[0] - $prevhid) > 1) { // Should be equal, for consecutively increasing HIDs, if difference > 1, there is gap
								$freehid = $prevhid + 1;
							}
							$prevhid = $house[0];
						}*/
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		$house = [];
		fclose($f); // ALHAMDOLILLAH houses list loaded
		if ($HID == 0) { // No match found, add new House INSHAALLAH ALHAMDOLILLAH
			if ($jdata["HID"] > 0) {
				$jdata["HID"] = -1;
			}
			//if ($freehid == 0) {
			//if ($i > 0) {
			$freehid = max($hidlist) + 1; // Couldn't find free HID, so take the maximum HID already assigned to house and increment by 1.
			//} else {
			//	$freehid = 1;
			//}
			//}
			$HID = $freehid;
			$houseslist[$i]["HID"] = $freehid;
			$houseslist[$i]["House"] = $jdata["House"];
		}
		// Write houses file
		$f = fopen($file, "w");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions.");
		}
		foreach($houseslist as $h) {
			fputs($f, $h["HID"] . $fdelimiter . $h["House"] . "\r\n");
		}
		fclose($f);
		// Write patients file
		$filename = $filehouseprefix . $HID . $filehousesuffix;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "w");
		if (!$f) {
			throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions.");
		}
		foreach($jdata["Patients"] as $p) {
			fputs($f, trim($p) . "\r\n");
		}
		fclose($f);
		//if (($jdata["HID"] > 0) && ($jdata["HID"] != $HID)) { // HID was not found, so added new entry ALHAMDOLILLAH
		if ($jdata["HID"] == -1) { // HID was not found, so added new entry ALHAMDOLILLAH
			//$ret["message"] = "House was not found. Added new House entry.";
			$ret["message"] = "Saved successfully.";
		} else {
			$ret["message"] = "Saved successfully.";
		}
		$ret["status"] = true;
		$ret["data"] = $jdata["House"];
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}

if ($jdata["Action"] == "LoadHousesList") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = trim($house[0]);
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);

		$ret["status"] = true;
		$ret["message"] = "ALHAMDOLILLAH houses list loaded successfully.";
		$ret["data"] = $houseslist;

	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}



if ($jdata["Action"] == "EditHouse") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = trim($house[0]);
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					} else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}
				}
			}
		}
		fclose($f);
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = "";
		foreach($houseslist as $h) {
			if ($h["HID"] == $jdata["HID"]) {
				$house["HID"] = $h["HID"];
				$house["House"]  = $h["House"];
			}
		}
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				//$fs = filesize($file);
				if (filesize($file) > 0) {
					rewind($f);
					while ($fline = fgets($f)) {
						$fline = trim($fline);
						if ($house["Patients"] == "") {
							$house["Patients"] = $fline;
						} else {
							$house["Patients"] = $house["Patients"] . "
" . $fline;
						}
					}
				}
				/*if ($fs > 0) {
					rewind($f); // just in case
					//$house["Patients"] = fread($f, $fs);
				}*/
				fclose($f);
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH house data fetched successfully for edit.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House ID. House not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}

if ($jdata["Action"] == "DeleteHouse") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$HID = 0;
		$i = 0;
		$jdata["House"] = "";
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						if ($house[0] == $jdata["HID"]) {
							$HID = $house[0];
							$jdata["House"] = $house[1];
						} else {
							$houseslist[$i]["HID"] = trim($house[0]);
							$houseslist[$i]["House"] = $house[1];
							$i = $i + 1;
						}
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);
		// Write houses file
		$f = fopen($file, "w");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions.");
		}
		foreach($houseslist as $h) {
			fputs($f, $h["HID"] . $fdelimiter . $h["House"] . "\r\n");
		}
		fclose($f);
		// Delete patients file
		$filename = $filehouseprefix . $HID . $filehousesuffix;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$ret["message"] = "";
		if (file_exists($file)) {
			if (!unlink($file)) {
				$ret["message"] = "<br />Failed to delete Patients file: " . $file;
			}
		}
		if ($HID != $jdata["HID"]) { // HID was not found, AOOZOBILLAH
			$ret["status"] = false;
			$ret["message"] = "House was not found. Delete operation not performed.";
		} else {
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH house deleted successfully." . $ret["message"];
		}
		$ret["data"] = $jdata["House"];
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}



if ($jdata["Action"] == "LoadPatientsList") { // Same code as "EditHouse" ALHAMDOLILLAH
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = trim($house[0]);
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = [];
		foreach($houseslist as $h) {
			if ($h["HID"] == $jdata["HID"]) {
				$house["HID"] = $h["HID"];
				$house["House"]  = $h["House"];
			}
		}
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);
					$i = 0;
					while ($fline = fgets($f)) {
						$fline = trim($fline);
						if ($fline != "") {
							$patientslist[$i] = $fline;
							$i = $i + 1;
						}
					}
					$i = 0;
					foreach($patientslist as $p) {	//026391  Biehler, Torsten, 16.05.1939
						$pat = explode($housepatidseparator, $p);
						// $pat[0] = 026391
						// $pat[1] = Biehler, Torsten, 16.05.1939
						/*if (!(count($pat) == 2)) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />PID{space}PatientLastName,{space}PatientFirstName,{space}dd.mm.yyyy");
						}*/
						$pid = $pat[0];
						/*
						// Name etc verification starts
						$pdata = explode(" ", $pat[1]);
						// $pdata[0] = Biehler,
						// $pdata[1] = Torsten,
						// $pdata[2] = 16.05.1939
						if (!(count($pdata) == 3)) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect name and date format. Correct format:<br />PatientLastName,{space}PatientFirstName,{space}dd.mm.yyyy");
						}
						$plname = trim(str_replace(",", " ", $pdata[0]));	// To replace commas within names to spaces // $plname = str_replace(",", " ", $pdata[0]);
						$pfname = trim(str_replace(",", " ", $pdata[1]));	// To replace commas within names to spaces // $pfname = str_replace(",", " ", $pdata[1]);
						$pddate = trim($pdata[2]);
						// Start date format verification - Date format dd.mm.yyyy

						$pdatedata = explode(".", $pddate);
						if (!(count($pdatedata) == 3)) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Correct format: dd.mm.yyyy");
						}
						if (!(is_numeric($pdatedata[0]) && (strlen($pdatedata[0]) == 2) && (intval($pdatedata[0]) >= 1) && (intval($pdatedata[0]) <= 31))) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Day must be two digits and between 1 and 31.");
						}
						if (!(is_numeric($pdatedata[1]) && (strlen($pdatedata[1]) == 2) && (intval($pdatedata[1]) >= 1) && (intval($pdatedata[1]) <= 12))) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Month must be two digits and between 1 and 12.");
						}
						if (!(is_numeric($pdatedata[2]) && (strlen($pdatedata[2]) == 4) && (intval($pdatedata[2]) >= 1700) && (intval($pdatedata[2]) <= 2999))) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Month must be two digits and between 1700 and 2999.");
						}*/
						// End date format verification
						$house["Patients"][$i]["PID"] = $pid;
						//$house["Patients"][$i]["FName"] = $pfname;
						//$house["Patients"][$i]["LName"] = $plname;
						//$house["Patients"][$i]["FullName"] = $plname . ", " . $pfname;
						//$house["Patients"][$i]["DDate"] = $pddate;
						$house["Patients"][$i]["Patient"] = $p;
						$pidcount = strlen($pid);
						$tmp = explode(", ", substr($p, strlen($pid) + strlen($housepatidseparator), strlen($p)));
						$house["Patients"][$i]["PatientData"][0] = $pid;
						for ($j = 0; $j < count($tmp); $j++) {
							$house["Patients"][$i]["PatientData"][($j+1)] = $tmp[$j];
						}
						$i = $i + 1;
					}
				}
				fclose($f);
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH house data fetched successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House ID. House not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}







if ($jdata["Action"] == "LoadPatientDescription") {
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$patient["PID"] = 0;
		$patient["PatientData"] = [];
		///////////////////////////////// Read samba workstation file
		$wpatient = []; // workstation patient
		//$wpatient[0] = 0;
		$filename = $fileworkstation;
		//if ((!array_key_exists("wsid", $_GET)) || ($_GET["wsid"] == "")) {
			//echo "Error: wsid not set, eg. box.php?wsid=t0";
			//die;
		//}
		$wfound = false;
		$i = 0;
		if ((array_key_exists("wsid", $jdata)) && ($jdata["wsid"] != "")) {
			$wsid = trim($jdata['wsid']);
			$file = join(DIRECTORY_SEPARATOR, array($pathworkstation, $workstations[$wsid], $filename));
			if (file_exists($file)) {
				$f = fopen($file, "r");
				if ($f) {
					//throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
					$fs = filesize($file);
					if ($fs > 0) {
						$wfound = true;
						rewind($f); // just in case
						//$patientslist = fread($f, $fs);
						$i = 0;
						//while ($fline = fgets($f)) $fline = trim($fline);
						while (($fline = fgets($f)) && ($i < 10)) {
							$fline = trim($fline);
							$wpatient[$i] = $fline;
							$i = $i + 1;
						}
					}
				}
				fclose($f);
			}
			$pfound = false; // patient found
			if ($i > 4) {
				if (strlen($wpatient[4]) >= 8) {
					$wtmpd = substr($wpatient[4], 0, 2);
					$wtmpm = substr($wpatient[4], 2, 2);
					$wtmpy = substr($wpatient[4], 4, 4);
					$wpatient[4] = $wtmpd . "." . $wtmpm . "." . $wtmpy;
				}
			}
			$i = 0;
			$wpdata = "";
			$locationtext = "";
			$locationquery = "";
			while(array_key_exists($i, $wpatient) && ($i < 10)) {
				if (trim($wpatient[$i]) != "") {
					switch($i) {
						case 0:
							//$wpdata = intval($wpatient[$i]);
							break;
						case 1:
							//$wpdata = $wpdata . $housepatidseparator . $wpatient[$i];
							$wpdata = $wpatient[$i];
							break;
						case 3:
							break;
						case 5:
							if (strlen($wpatient[$i]) > 20) {
								$locationtext = substr($wpatient[$i], 0, 20);
							} else {
								$locationtext = $wpatient[$i];
							}
							$locationquery = $wpatient[$i];
							/*if (strlen($wpatient[$i]) > 20) {
								$wpdata = $wpdata . ", <a href=https://maps.google.com/?q=" . urlencode($wpatient[$i]) . ">" . substr($wpatient[$i], 0, 20) . "</a>";
							} else {
								$wpdata = $wpdata . ", <a href=https://maps.google.com/?q=" . urlencode($wpatient[$i]) . ">" . $wpatient[$i] . "</a>";
							}*/
							break;
						case 6:
							if (strlen($wpatient[$i]) > 20) {
								$locationtext = $locationtext . ", " . substr($wpatient[$i], 0, 20);
							} else {
								$locationtext = $locationtext . ", " . $wpatient[$i];
							}
							$locationquery = $locationquery . ", " . $wpatient[$i];
							/*if (strlen($wpatient[$i]) > 20) {
								$wpdata = $wpdata . ", " . substr($wpatient[$i], 0, 20);
							} else {
								$wpdata = $wpdata . ", " . $wpatient[$i];
							}*/
							break;
						case 7: // telephone	Tel: 4626282 (area code missing? 0761-4626282)</h4>
								if (strlen($wpatient[$i]) <= 8) {
									$wpdata = $wpdata . ", Tel: " . trim($wpatient[$i]) . " (area code missing? " . $TelAreaCode . "-" . trim($wpatient[$i]) . ")";
								} else {
									$wpdata = $wpdata . ", Tel: " . trim($wpatient[$i]);
								}
							break;
						default:
							$wpdata = $wpdata . ", " . $wpatient[$i];
					}
					if ($i == 6) {
						if (trim($locationtext) != "") {
							$wpdata = $wpdata . ", " . $locationtext . "<a href=https://maps.google.com/?q=" . urlencode($locationquery) . "><img src=\"gmaps.png\" alt=\"Link to map\"></a>";
						}
					}
					$i = $i + 1;
				}
				//$wpdata = intval($wpatient[0]) . $housepatidseparator . $wpatient[1] . ", " . $wpatient[2] . ", " . $wpatient[4]; // Gender . $wpatient[3];
			}
			//$pat = explode($housepatidseparator, $p);
			// $pat[0] = 026391
			// $pat[1] = Biehler, Torsten, 16.05.1939
			//$pid = $pat[0];
			// End date format verification
			/*$PatientFields = [	"FName",
										"LName",
										"BDate",
										"Street",
										"ZipCity",
										"Telephone"	];*/
			if (array_key_exists(0, $wpatient)) {
				$patient["PID"] = $wpatient[0];
			}
			//$house["Patients"][$i]["FName"] = $pfname;
			//$house["Patients"][$i]["LName"] = $plname;
			//$house["Patients"][$i]["FullName"] = $plname . ", " . $pfname;
			//$house["Patients"][$i]["BDate"] = $pddate;
			$patient["Patient"] = $wpdata;
			if (array_key_exists(0, $wpatient)) {
				$patient["PatientData"][0] = $wpatient[0];
			}
			for ($j = 0; $j < count($wpatient); $j++) {
				$patient["PatientData"][$j] = $wpatient[$j];
				//$patient[$PatientFields[$j]] = $wpatient[$j];
			}
		}
		if ($wfound == true) {
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH wsid patient data data found.";
		} else {
			//$ret["status"] = false;
			$ret["status"] = true;
			$ret["message"] = "Patient data not found with wsid.";
		}
		$ret["data"] = $patient;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}





///////////// Not being used
if ($jdata["Action"] == "LoadPatientData") { ///////////// Not being used
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$patient["PID"] = 0;
		$patient["PatientData"] = [];
		$filename = $filehouseslist;
		//$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");// or die("Unable to open file: " . $file . "<br />Please check directory/ file permissions");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$HID = 0;
		$ival = 0;
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			$hfound = false;
			while (($fline = fgets($f)) && ($hfound == false)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						if (trim($house[0]) == $jdata["HID"]) {
							$HID = trim($house[0]);
							$ival = $i; // save $i value
							$hfound = true;
							//echo "found" . " $i " . $HID . "||";
						}
						$houseslist[$i]["HID"] = trim($house[0]);
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					}/*else
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					*/
				}
			}
		}
		fclose($f); // ALHAMDOLILLAH houses list loaded
		//if ($HID == 0) { // No match found, add new House INSHAALLAH ALHAMDOLILLAH
		/*if ($HID > 0)  // ALHAMDOLILLAH house found
		} else
			$u = 0;
		}*/
		$u = $ival;
		$pfound = false;
		$patient = [];
		//echo $u . "-" . $ival . "-" . count($houseslist);
		while (($pfound == false) && ($u < count($houseslist))) {
			// Search all houses
			$house["HID"] = $houseslist[$u]["HID"];
			$house["House"]  = $houseslist[$u]["House"];
			//echo ">>" .  $house["HID"];
			if ($house["HID"] > 0) {
				$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
				//echo "searching" . $filename . "<br />";
				$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
				if (file_exists($file)) {
					$f = fopen($file, "r");
					if ($f) {
						$fs = filesize($file);
						$p = "";
						if ($fs > 0) {
							rewind($f); // just in case
							//$patientslist = fread($f, $fs);
							$i = 0;
							while (($fline = fgets($f)) && ($pfound == false)) {
								$fline = trim($fline);
								if ($fline != "") {
									$pat = null;
									$pat = explode($housepatidseparator, $fline);
									if (intval(trim($pat[0])) == intval($jdata["PID"])) {
										$pfound = true;
										$p = $fline;
										/*
										if (intval($pat[0]) == intval($wpatient[0])) { // patient id matched
											if ($pfound == false) {
												$pfound = true;
												$patientslist[$i] = $wpdata;
												if ($house["Patients"] == "") {
													$house["Patients"] = $patientslist[$i];
												} else {
													$house["Patients"] = $house["Patients"] . "
	" . $patientslist[$i];
												}
											} //else  // repeated entry, ignore
										} else { // patient id did not match
											$patientslist[$i] = $fline;
											if ($house["Patients"] == "") {
												$house["Patients"] = $patientslist[$i];
											} else {
												$house["Patients"] = $house["Patients"] . "
	" . $patientslist[$i];
											}
										}
										$i = $i + 1;
										*/
									} // if intval()
								} // if $fline != ""
							} // end while
							fclose($f);
							// $i = 0;
							// foreach($patientslist as $p) 	//026391  Biehler, Torsten, 16.05.1939
							$pat = explode($housepatidseparator, $p);
							// $pat[0] = 026391
							// $pat[1] = Biehler, Torsten, 16.05.1939
							$pid = $pat[0];
							// End date format verification
							/*$PatientFields = [	"FName",
														"LName",
														"BDate",
														"Street",
														"ZipCity",
														"Telephone"	];*/
							$patient["PID"] = $pid;
							//$house["Patients"][$i]["FName"] = $pfname;
							//$house["Patients"][$i]["LName"] = $plname;
							//$house["Patients"][$i]["FullName"] = $plname . ", " . $pfname;
							//$house["Patients"][$i]["BDate"] = $pddate;
							//--$patient["Patient"] = $p;
							$nopiddata = substr($p, strlen($pid) + strlen($housepatidseparator), strlen($p));
							$patient["Patient"] = $nopiddata;
							$pidcount = strlen($pid);
							$tmp = explode(", ", $nopiddata);
							$patient["PatientData"][0] = $pid;
							for ($j = 0; $j < count($tmp); $j++) {
								$patient["PatientData"][($j+1)] = $tmp[$j];
								$patient[$PatientFields[$j]] = $tmp[$j];
							}

							/*
							if ($i > 4) {
								if (strlen($wpatient[4]) >= 8) {
									$wtmpd = substr($wpatient[4], 0, 2);
									$wtmpm = substr($wpatient[4], 2, 2);
									$wtmpy = substr($wpatient[4], 4, 4);
									$wpatient[4] = $wtmpd . "." . $wtmpm . "." . $wtmpy;
								}
							}
							$i = 0;
							//$wpdata = "";
							while(array_key_exists($i, $wpatient) && ($i < 10)) {
								if (trim($wpatient[$i]) != "") {
									switch($i) {
										case 0:
											$wpdata = intval($wpatient[$i]);
											break;
										case 1:
											$wpdata = $wpdata . $housepatidseparator . $wpatient[$i];
											break;
										case 3:
											break;
										case 7:
											break;
										default:
											$wpdata = $wpdata . ", " . $wpatient[$i];
									}
									$i = $i + 1;
								}
								//$wpdata = intval($wpatient[0]) . $housepatidseparator . $wpatient[1] . ", " . $wpatient[2] . ", " . $wpatient[4]; // Gender . $wpatient[3];
							}
							*/
							//$patient["PatientDataLine"] = $pid;
							//$i = $i + 1;
							//} // end foreach
						} // if ($fs > 0)
					} // end if ($f)
				} // if file_exists($file)
			} // if $house["HID"] > 0
			$u = $u + 1;
		} // end while
		if ($pfound == true) {
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH patient data found.";
		} else {
			//$ret["status"] = false;
			$ret["status"] = true;
			$ret["message"] = "Patient data not found in any house list.";
		}
		$ret["data"] = $patient;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}








if ($jdata["Action"] == "DeleteAllHouses") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0 // check format HID{delimiter}HouseName, or else ignore entry
						$pfilename = $filehouseprefix . $house[0] . $filehousesuffix; // Patients file
						$pfile = join(DIRECTORY_SEPARATOR, array('textdata', $pfilename));
						if (file_exists($pfile)) {
							if (!unlink($pfile)) {
								$ret["message"] = $ret["message"] . "<br />Failed to delete Patients file: " . $file;
							}
						}
					}
				}
			}
		}
		fclose($f);
		if (file_exists($file)) {
			if (!unlink($file)) {
				$ret["message"] = "<br />Failed to delete Houses file: " . $file;
			}
		}
		$ret["data"] = "";
		if ($ret["message"] == "") {
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH list of all houses and all patients lists deleted successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "There were some errors while attempting to delete Houses and Patients lists:<br />" . $ret["message"];
		}
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}





if ($jdata["Action"] == "UpdatePatientsList") {
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$filename = $filehouseslist;
		//$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");// or die("Unable to open file: " . $file . "<br />Please check directory/ file permissions");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$HID = 0;
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						if (trim($house[0]) == $jdata["HID"]) {
							$HID = trim($house[0]);
							$houseslist[$i]["HID"] = trim($house[0]);
							$houseslist[$i]["House"] = $house[1];
						}
						$i = $i + 1;
					}/*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f); // ALHAMDOLILLAH houses list loaded
		if ($HID == 0) { // No match found, add new House INSHAALLAH ALHAMDOLILLAH
			if ($jdata["HID"] > 0) {
				$jdata["HID"] = -1;
			}
		}
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = "";
		foreach($houseslist as $h) {
			if ($h["HID"] == $jdata["HID"]) {
				$house["HID"] = $h["HID"];
				$house["House"]  = $h["House"];
			}
		}

		///////////////////////////////// Read samba workstation file
		$wpatient = []; // workstation patient
		$wpatient[0] = 0;
		$filename = $fileworkstation;
		if ((!array_key_exists("wsid", $_GET)) || ($_GET["wsid"] == "")) {
			echo "Error: wsid not set, eg. box.php?wsid=t0";
			die;
		}
		$wsid = trim($_GET['wsid']);
		$file = join(DIRECTORY_SEPARATOR, array($pathworkstation, $workstations[$wsid], $filename));
		if (file_exists($file)) {
			$f = fopen($file, "r");
			if ($f) {
				//throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);
					$i = 0;
					//while ($fline = fgets($f)) $fline = trim($fline);
					while (($fline = fgets($f)) && ($i < 10)) {
						$fline = trim($fline);
						//if ($i < 10) {
							$wpatient[$i] = $fline;
							$i = $i + 1;
						//} //else {
							//throw new Exception("Incorrect Workstation Patient file format: " . $file . " Too long. Only 10 lines allowed");
						//}
					}
				}
			}
			fclose($f);
		}
		$pfound = false; // patient found
		if ($i > 4) {
			if (strlen($wpatient[4]) >= 8) {
				$wtmpd = substr($wpatient[4], 0, 2);
				$wtmpm = substr($wpatient[4], 2, 2);
				$wtmpy = substr($wpatient[4], 4, 4);
				$wpatient[4] = $wtmpd . "." . $wtmpm . "." . $wtmpy;
			}
		}
		$i = 0;
		//$wpdata = "";
		while(array_key_exists($i, $wpatient) && ($i < 10)) {
			if (trim($wpatient[$i]) != "") {
				switch($i) {
					case 0:
						$wpdata = intval($wpatient[$i]);
						break;
					case 1:
						$wpdata = $wpdata . $housepatidseparator . $wpatient[$i];
						break;
					case 3:
						break;
					case 5:
					case 6:
						if (strlen($wpatient[$i]) > 20) {
							$wpdata = $wpdata . ", " . substr($wpatient[$i], 0, 20);
						} else {
							$wpdata = $wpdata . ", " . $wpatient[$i];
						}
						break;
					case 7:
						break;
					default:
						$wpdata = $wpdata . ", " . $wpatient[$i];
				}
				$i = $i + 1;
			}
			//$wpdata = intval($wpatient[0]) . $housepatidseparator . $wpatient[1] . ", " . $wpatient[2] . ", " . $wpatient[4]; // Gender . $wpatient[3];
		}
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);
					$i = 0;
					while ($fline = fgets($f)) {
						$fline = trim($fline);
						if ($fline != "") {
							$pat = explode(" ", $fline);
							if (intval($pat[0]) == intval($wpatient[0])) { // patient id matched
								if ($pfound == false) {
									$pfound = true;
									$patientslist[$i] = $wpdata;
									if ($house["Patients"] == "") {
										$house["Patients"] = $patientslist[$i];
									} else {
										$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
									}
								} //else { // repeated entry, ignore
							} else { // patient id did not match
								$patientslist[$i] = $fline;
								if ($house["Patients"] == "") {
									$house["Patients"] = $patientslist[$i];
								} else {
									$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
								}
							}
							$i = $i + 1;
						}
					}
					if (($pfound == false) && ($wpatient[0] > 0)) {
						$patientslist[$i] = $wpdata;
						if ($house["Patients"] == "") {
							$house["Patients"] = $patientslist[$i];
						} else {
							$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
						}
					}
					fclose($f);
					// Update house patients file
					$f = fopen($file, "w");
					if (!$f) {
						throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions.");
					}
					foreach($patientslist as $p) {
						fputs($f, trim($p) . "\r\n");
					}
					fclose($f);
				}
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH patients list updated successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House ID. House not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}










// This function is not being used, see houselist_insert.php
//?Action=UpdatePatientsListStandalone&arch_exp=/var/samba/trp&house=aaa


if ($jdata["Action"] == "UpdatePatientsListStandalone") {
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$jdata["HID"] = 0;
		$HID = 0;
		$HouseName = trim($_GET["house"]); // input variables
		$fileworkstation = $_GET["arch_exp"]; // input variables
		if ((!array_key_exists("wsid", $_GET)) || ($_GET["wsid"] == "")) {
			echo "Error: wsid not set, eg. box.php?wsid=t0";
			die;
		}
		$wsid = trim($_GET['wsid']);

		$filename = $filehouseslist;
		//$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "r");// or die("Unable to open file: " . $file . "<br />Please check directory/ file permissions");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = "";
		$HID = 0;
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = fgets($f)) {
				$fline = trim($fline);
				if ($fline != "") {
					$h = explode($fdelimiter, $fline);
					if ((count($h) == 2) && (intval($h[0]) > 0)) { // HID must be greater than 0
						if (trim(strtolower($h[1])) == strtolower($HouseName)) {
							$HID = trim($h[0]);
							$house["HID"] = $HID;
							$house["House"] = trim($h[1]);
							$houseslist[$i]["HID"] = $h[0];
							$houseslist[$i]["House"] = $h[1];
						}
						$i = $i + 1;
					}/*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f); // ALHAMDOLILLAH houses list loaded

		///////////////////////////////// Read samba workstation file
		$wpatient = []; // workstation patient
		$wpatient[0] = 0;
		$filename = $fileworkstation;
		if ((!array_key_exists("wsid", $_GET)) || ($_GET["wsid"] == "")) {
			echo "Error: wsid not set, eg. box.php?wsid=t0";
			die;
		}
		$wsid = trim($_GET['wsid']);
		$file = join(DIRECTORY_SEPARATOR, array($pathworkstation, $workstations[$wsid], $filename));
		if (file_exists($file)) {
			$f = fopen($file, "r");
			if ($f) {
				//throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);
					$i = 0;
					//while ($fline = fgets($f)) $fline = trim($fline);
					while (($fline = fgets($f)) && ($i < 10)) {
						$fline = trim($fline);
						//if ($i < 10) {
							$wpatient[$i] = $fline;
							$i = $i + 1;
						//} //else {
							//throw new Exception("Incorrect Workstation Patient file format: " . $file . " Too long. Only 10 lines allowed");
						//}
					}
				}
			}
			fclose($f);
		}
		$pfound = false; // patient found
		if ($i > 4) {
			if (strlen($wpatient[4]) >= 8) {
				$wtmpd = substr($wpatient[4], 0, 2);
				$wtmpm = substr($wpatient[4], 2, 2);
				$wtmpy = substr($wpatient[4], 4, 4);
				$wpatient[4] = $wtmpd . "." . $wtmpm . "." . $wtmpy;
			}
		}
		$i = 0;
		//$wpdata = "";
		while(array_key_exists($i, $wpatient) && ($i < 10)) {
			if (trim($wpatient[$i]) != "") {
				switch($i) {
					case 0:
						$wpdata = intval($wpatient[$i]);
						break;
					case 1:
						$wpdata = $wpdata . $housepatidseparator . $wpatient[$i];
						break;
					case 3:
						break;
					case 5:
					case 6:
						if (strlen($wpatient[$i]) > 20) {
							$wpdata = $wpdata . ", " . substr($wpatient[$i], 0, 20);
						}
						break;
					case 7:
						break;
					default:
						$wpdata = $wpdata . ", " . $wpatient[$i];
				}
				$i = $i + 1;
			}
			//$wpdata = intval($wpatient[0]) . $housepatidseparator . $wpatient[1] . ", " . $wpatient[2] . ", " . $wpatient[4]; // Gender . $wpatient[3];
		}
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);
					$i = 0;
					while ($fline = fgets($f)) {
						$fline = trim($fline);
						if ($fline != "") {
							$pat = explode(" ", $fline);
							if (intval($pat[0]) == intval($wpatient[0])) { // patient id matched
								if ($pfound == false) {
									$pfound = true;
									$patientslist[$i] = $wpdata;
									if ($house["Patients"] == "") {
										$house["Patients"] = $patientslist[$i];
									} else {
										$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
									}
								} //else { // repeated entry, ignore
							} else { // patient id did not match
								$patientslist[$i] = $fline;
								if ($house["Patients"] == "") {
									$house["Patients"] = $patientslist[$i];
								} else {
									$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
								}
							}
							$i = $i + 1;
						}
					}
					if (($pfound == false) && ($wpatient[0] > 0)) {
						$patientslist[$i] = $wpdata;
						if ($house["Patients"] == "") {
							$house["Patients"] = $patientslist[$i];
						} else {
							$house["Patients"] = $house["Patients"] . "
" . $patientslist[$i];
						}
					}
					fclose($f);
					// Update house patients file
					$f = fopen($file, "w");
					if (!$f) {
						throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions.");
					}
					foreach($patientslist as $p) {
						fputs($f, trim($p) . "\r\n");
					}
					fclose($f);
				}
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH patients list updated successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House ID. House not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}

}


if ($jdata["Action"] == "SearchPatient") {
	try {
		include("engine.php");
		$conn = DBOpenConnection();
		$sql = "SELECT * FROM patimport order by laName asc;";
		$stmt = $conn->prepare($sql);
		//$stmt->bindValue(':Barcode', $jdata['Barcode'], PDO::PARAM_STR);

		$stmt->execute(); // true or false
		$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

		$list = $stmt->fetchAll();
		$matchlist = array();
		if (!$list) {
			$ret["status"] = false;
			$ret["message"] = false;
		}
		else {
			$ret["status"] = true;
			$search = $jdata["Search"];
			if (is_numeric($search)) { // numeric, patient number
				$match = array();
				$patNr = $search;
				$search = "/^" . preg_quote($search) . ".*/i";
				for ($i=0; $i<count($list); $i++) {
					$id = $list[$i]["patNrP"];
					//echo $name . "\n";
					if (preg_match($search, $id) == 1) {
						//if (count($matchlist) < 7) {
							if ($id == $patNr) {
								array_push($match, $list[$i]);
							} else {
								array_push($matchlist, $list[$i]);
							}
						//}
					}
				}
				usort($matchlist, "cmp");
				if (count($match) > 0) {
					array_unshift($matchlist, $match[0]);
				}
			} else {
				$sexp = explode(",", $search);
				if (count($sexp) > 1) {
					$s0 = $sexp[0];
					$s1 = "";
					for ($i=1; $i<count($sexp); $i++) {
						if ($s1 == "") {
							$s1	= $sexp[$i];
						} else {
							$s1 = $s1 . "," . $sexp[$i];
						}
					} // /.*albr.*,.*t.*/i
					//echo "s0: " . $s0 . "\n";
					//echo "s1: " . $s1 . "\n\n";
					$search = "/.*" . preg_quote($s0) . ".*,.*" . preg_quote($s1) . ".*/i";
				} else {
					$search = "/.*" . preg_quote($search) . ".*/i";
				}
				//echo "search: " . $search . "\n\n";
				//echo "DB results: " . count($list) . "\n\n";
				for ($i=0; $i<count($list); $i++) {
					$name = $list[$i]["laName"] . ", " . $list[$i]["fiName"];
					//echo $name . "\n";
					if (preg_match($search, $name) == 1) {
						//if (count($matchlist) < 7) {
							array_push($matchlist, $list[$i]);
						//}
					}
				}
			} // end if (is_numeric($search)) else
			//echo "Matchlist results: " . count($matchlist) . "\n\n";
			//print_r($matchlist);
		}
		$ret["data"] = $matchlist;
		//$ret["message"] = $search;
	}
	catch(PDOException $e) {
	    $ret["status"] = false;
	    $ret["message"] = $e->getMessage();
	    $ret["data"] = array();
	}
	$conn = null;
}


function cmp($a, $b)
{
    if ($a["patNrP"] == $b["patNrP"]) {
        return 0;
    }
    return ($a["patNrP"] < $b["patNrP"]) ? -1 : 1;
}






//echo json_encode(utf8ize($ret), JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
echo json_encode($ret, JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8

// https://stackoverflow.com/questions/19361282/why-would-json-encode-return-an-empty-string
function utf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_encode($d);
	}
	return $d;
}

function deutf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_decode($d);
	}
	return $d;
}

?>