<!doctype html public "-//w3c//dtd html 4.01 transitional//de">
<html lang="de">

<head>
    <title>Houselist documents of all patients download do browser cache</title>
    <meta name="robots" content="nofollow">
    <link rel="stylesheet" type="text/css" href="style_archiv.css" />
    <style type="text/css">
    #houselistDownloadText {
        margin-top: 20px;
        margin-bottom: 20px;
    }

    #houselistDownloadText a {
        margin: 10px;
        padding: 10px;
        background: #729FCF;
        border: none;
        width: 17%;
        height: auto;
        color: black;
        text-decoration: none;
        display: inline-block;
        text-align: center;
        line-height: 30px;
        font-size: 20px;
        min-width: 220px;
    }

    #houselistDownloadText h2 select {
        width: 100px;
        height: 30px;
    }

    #houselistDownloadText a.disabled {
        pointer-events: none;
        background: #aec3da;
        color: #797676;
        cursor: not-allowed;
        opacity: 0.5;
        text-decoration: none;
    }
    </style>
</head>

<body>
    <div id="dialog">
        <form>
            <div id="DialogTitle">Delete?</div>
            <div class="table">
                <div class="rowsimple">
                    <div class="colsimple">
                        <span id="DialogData">sdf dsf jdfj df</span>
                    </div>
                </div>
                <div class="rowsimple">
                    <div class="colsimple">
                        <span id="DialogControls">
                            <input type="button" class="buttongeneral" name="Close" id="Close" value="Close"
                                onclick="CloseDialog();" />
                        </span>
                    </div>
                </div>
            </div><?php /* End <div class="table"> */ ?>
        </form>
    </div><?php /* End <div id="dialog"> */ ?>
    <?php
    include("./db72.php");
    $HID1 = $_GET['HID'];
    $TimeIntervalCon = $_GET['TimeInterval'];
    $filehid = 'textdata' . DIRECTORY_SEPARATOR . 'house' . $HID1 . '.txt';
    $openfilehid = fopen($filehid, "r")  or die("Unable to open file: " . $filehid . "<br />Please check directory/ file permissions");
    if (!$openfilehid) {
        throw new Exception("This Patient number in houselist not found: " . basename($file) . "<br />Please check directory/ file permissions");
    }
    $readfilehid= fread($openfilehid,filesize("$filehid"));
    fclose($openfilehid);
    $filehidarr = explode(PHP_EOL, trim($readfilehid));
    $patNrStr = '';
    if(!empty($filehidarr) && count($filehidarr))
    {
        foreach ($filehidarr as $key => $valueHID) {
            if(!empty($valueHID))
            {
                $patNr1 = explode(' ', trim($valueHID));
                $patNrStr .= $patNr1[0] . ', ';
            }
        }
        $patNrStr = trim($patNrStr, ', ');
    }

    if(!empty($patNrStr))
    {
        $timeIntervalSqlCon = "";
        if($TimeIntervalCon != 0)
        {
            $timeIntervalSqlCon = " and datUser >= DATE_SUB(now(), INTERVAL $TimeIntervalCon MONTH)";
        }
        $SQL="select count(*) as total_record from doarch where patNr in (" . $patNrStr . ") $timeIntervalSqlCon and docFileName is not null;";
        $res_scans=mysqli_query($connect, $SQL);
        $row_scans = mysqli_fetch_assoc($res_scans);
        $total_record = $row_scans['total_record'];
    }
    $timesecArr = [1,2,5,10];
    ?>
    <div id="houselistDownloadText">
        <h2> &nbsp;&nbsp; <?php echo $total_record;?> Dokumente für den Download gefunden.
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Anzahl Monate zurück:
            <select name="TimeInterval" id="TimeInterval" onchange="SelectTimeInterval();">
                <option value="3" <?php echo ($TimeIntervalCon == 3 ? "selected" : "")?>>3 Monate</option>
                <option value="6" <?php echo ($TimeIntervalCon == 6 ? "selected" : "")?>>6 Monate</option>
                <option value="12" <?php echo ($TimeIntervalCon == 12 ? "selected" : "")?>>12 Monate</option>
                <option value="24" <?php echo ($TimeIntervalCon == 24 ? "selected" : "")?>>2 Jahre</option>
                <option value="0" <?php echo ($TimeIntervalCon == 0 ? "selected" : "")?>>Alle</option>
            </select>
        </h2>

        <?php
        if($total_record != 0)
        {
            foreach ($timesecArr as $key => $value) {
                echo "<a href=\"javascript:void(0)\" class=\"downloadLink \" onClick=\"OpenDocuments('" . $value . "', '" . $HID1 . "', '" . $TimeIntervalCon . "');\">Download mit <br />Verzögerung je $value Sek.:<br />" . ($total_record * $value) . " Sek.</a>";
            }
        }
    ?>
    </div>

    <script type="text/javascript">
    var openedDocument = 0;

    function FetchGETVars() {
        var param = {};
        var urlsearch = document.location.search;
        if (urlsearch != "") {
            var getvars = urlsearch.split("?");
            if (getvars.length == 2) {
                var params = getvars[1].split("&");
                var p = {};
                Object.keys(params).forEach(function(key) {
                    p = params[key].split("=");
                    if (p.length == 2) {
                        param[p[0]] = p[1];
                    }
                });
            }
        }
        return param;
    }

    function Redirect(url, gobj = {}, preserve = true) {
        var gvars = "";
        Object.keys(gobj).forEach(function(key) {
            if (gvars.length > 0) {
                gvars = gvars + "&";
            }
            gvars = gvars + key + "=" + gobj[key];
        });
        var getparams = "";
        if (preserve == true) {
            var param = FetchGETVars();
            Object.keys(param).forEach(function(key) {
                //console.log(key + "=>" + param[key]);
                if (!gobj[key]) { // if GET variable same as the new one being set, ignore INSHAALLAH
                    getparams = getparams + key + "=" + param[key] + "&";
                }
            });
        }
        window.location = url + "?" + getparams + gvars;
    }

    function SelectTimeInterval() {
        var TimeInterval = document.getElementById("TimeInterval");
        if (TimeInterval.selectedIndex >= 0) {
            var gobj = {
                TimeInterval: TimeInterval.options[TimeInterval.selectedIndex].value,
                HID: <?php echo $HID1;?>
            };
            Redirect("houselist_downl_button_ger.php", gobj, true); // false, do not preserve current GET variables
        }
    }


    function OpenDocuments(DelayTime, HID, TimeInterval) {
        if (openedDocument > 1) {
            return;
        }
        var gobj = {
            delaytime: DelayTime,
            HID: HID,
            TimeInterval: TimeInterval
        };
        var downloadLinkArr = document.getElementsByClassName("downloadLink");
        for (var i = 0; i < downloadLinkArr.length; i++) {
            downloadLinkArr[i].className += " disabled";
        }
        ShowNotice("general", "Dokumente laden in den Zwischenspeicher...", "",
            "Bitte warten während die Dokumente laden.");
        setTimeout(() => {
            openedDocument++;
            Redirect("houselist_download.php", gobj, true); // false, do not preserve current GET variables
        }, 1000);
    }

    function ShowNotice(NType, NTitle, Notice = "", NData = "") {
        if (Notice == "") {
            Notice = NType;
        }
        document.getElementById("DialogTitle").innerText = NTitle;
        document.getElementById("DialogData").innerHTML = NData;
        document.getElementById("DialogData").style.height = "auto";
        document.getElementById("DialogControls").innerHTML = '';
        ShowDialog();
        document.getElementById("dialog").style.width = "100%";
    }

    function ShowDialog(box = "dialog") {
        var dialog = document.getElementById(box);
        var scrolly = document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop;
        dialog.style.top = scrolly + "px";
        dialog.style.visibility = "visible";
        dialog.style.opacity = "1";
    }

    function AutoCloseNotice() {
        setTimeout(() => {
            CloseDialog();
        }, <?php echo $NoticeTimeOut; ?>);
    }

    function CloseDialog() {
        DisablePDFAddon();
        document.getElementById("dialog").style.visibility = "hidden";
        document.getElementById("dialog").style.opacity = "0";
    }
    </script>
</body>

</html>